/*
	File:		MITest1.h

	Contains:	Declarations for multiple-inheritance test classes

	Copyright:	 1993-1994 by Apple Computer, Inc., all rights reserved.

*/

#ifndef __MITEST1__
#define __MITEST1__

#ifndef __LIBRARYMANAGER__
#include <LibraryManager.h>
#endif

#define kMMixin1ID	"quin:test$MMixin1,1.2"

class MMixin1 : public MDynamic
{
	protected:
						MMixin1(int a);
		virtual			~_CDECL MMixin1();
	
	public:
		virtual int		Add1(int a);
		virtual int		Sub1(int a);
		
	int		fFieldm;
};

#define kMMixin2ID	"quin:test$MMixin2,1.2"

class MMixin2 : public MDynamic
{
	protected:
						MMixin2(int a);
		virtual			~_CDECL MMixin2();
	
	public:
		virtual int		Add2(int a);
		virtual int		Sub2(int a);
		
	int		fFieldm;
};

#define kMMixin3ID	"quin:test$MMixin3,1.2"

class MMixin3 : public MDynamic
{
	protected:
						MMixin3(int a);
		virtual			~_CDECL MMixin3();
	
	public:
		virtual int		Add3(int a);
		virtual int		Sub3(int a);
		
	int		fFieldm;
};
//
// Non-shared class
//
class TMainClass : public TStdDynamic
{
	public:
						TMainClass(int a);
		virtual			~_CDECL TMainClass();
		

		virtual int		Mul(int a);
		virtual int		Div(int a);
		
	int		fFieldt;
};

#define kTMixedClassID	"quin:test$TMixedClass,1.2"

class TMixedClass : public TMainClass, virtual public MMixin1, public MMixin2
{
	public:
						TMixedClass(int a);
		virtual			~_CDECL TMixedClass();
		
		virtual int		Sub1(int a);
		virtual int		Div(int a);
		virtual int		Add2(int a);
};

#define kTMixedClass2ID	"quin:test$TMixedClass2,1.2"

class TMixedClass2 : public TMixedClass, virtual public MMixin1, public MMixin3
{
	public:
						TMixedClass2(int a);
		virtual			~_CDECL TMixedClass2();
		
		virtual int		Sub2(int a);
		virtual int		Mul(int a);
		virtual int		Add1(int a);
		virtual int		Add3(int a);
};

#endif
