/*
	File:		TestClass.h

	Contains:	Template declaration for test class

	Copyright:	 1991-1994 by Apple Computer, Inc., all rights reserved.

*/

#ifndef __TESTCLASS__
#define __TESTCLASS__

#ifndef __GLOBALNEW__
#include <GlobalNew.h>
#endif
#ifdef USEMPW
	#ifndef __ASLMCLIBS__
	#include <ASLMCLibs.h>
	#endif
#endif
#ifndef __TESTTOOL__
#include <TestTool.h>
#endif
#ifndef __LIBRARYMANAGERCLASSES__
#include <LibraryManagerClasses.h>
#endif

/**********************************************************************
** CLASS TNumber
***********************************************************************/

class TNumber : public TMatchObject
{
	public:
								TNumber(short);
		virtual					~_CDECL TNumber();

		virtual Boolean			_CDECL IsEqual(const void*) const;
		virtual unsigned long	_CDECL Hash() const;
		
		short	fNumber;
};

/**********************************************************************
** CLASS TNumberHasher
***********************************************************************/

class TNumberHasher : public THashObject
{
	public:
								TNumberHasher();
		virtual					~_CDECL TNumberHasher();

		virtual unsigned long	_CDECL Hash(const void*) const;
};

/**********************************************************************
** Macros for TTestxxxxxxx
***********************************************************************/

#define BodyTest(ClassName, ClassToTest)												\
	public:																	\
						_CDECL TTest##ClassName();									\
		virtual			~_CDECL TTest##ClassName();								\
																			\
		virtual void	_CDECL InitTest(BooleanParm verbose, BooleanParm debug, int argc, char** argv);			\
		virtual void	_CDECL RunTestIteration(BooleanParm verbose, BooleanParm debug);	\
		virtual void	_CDECL EndTest(BooleanParm verbose, BooleanParm debug);			\
																			\
	T##ClassToTest*	fTest													\

#define Constructor(ClassName)								\
TTest##ClassName :: TTest##ClassName()						\
{															\
	fTest = NULL;											\
}

#define Destructor(ClassName)						\
TTest##ClassName :: ~TTest##ClassName()				\
{													\
	delete fTest;									\
	fTest = NULL;									\
}

#endif
