/*
	File:		TestStandardPool.h

	Contains:	Declaration for TTestStandardPool class

	Copyright:	 1991-1994 by Apple Computer, Inc., all rights reserved.

*/

#ifndef __TESTSTANDARDPOOL__
#define __TESTSTANDARDPOOL__

#ifndef __TESTCLASS__
#include "TestClass.h"
#endif
#ifndef __LIBRARYMANAGERCLASSES__
#include <LibraryManagerClasses.h>
#endif

#define kTTestStandardPoolID	kTestToolPrefix "TTestStandardPool,1.2"


class TTestStandardPool : public TTestTool
{
	BodyTest(StandardPool, StandardPool);
	
	size_t	fSmallest;
	size_t	fLargest;
	size_t	fIterations;
	size_t	fAllocs;
	size_t	fDeletes;
	size_t	fReallocs;
};

/**********************************************************************
** Support class
***********************************************************************/

class TPoolTestOperation : public TOperation
{
	public:
						TPoolTestOperation(char** array, size_t fArraySize,
										   size_t small, size_t large);
		virtual			~_CDECL TPoolTestOperation();
		
		virtual void	_CDECL Process();
		
	char**	fArray;
	size_t	fArraySize;
	size_t	fSmallest;
	size_t	fLargest;
	size_t	fAllocs;
	size_t	fDeletes;
	size_t	fReallocs;
	Boolean	fFinished;
};



#endif


